↓ Skip to main content
  1. Posts/

poj 1065 Wooden Sticks

·730 words·2 mins
Note: This article is available in Chinese only. 本文暂无英文版本。 View original

Wooden Sticks Time Limit: 1000MS Memory Limit: 10000K Total Submissions: 19008 Accepted: 8012 Description

There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to prepare processing a stick. The setup times are associated with cleaning operations and changing tools and shapes in the machine. The setup times of the woodworking machine are given as follows: (a) The setup time for the first wooden stick is 1 minute. (b) Right after processing a stick of length l and weight w , the machine will need no setup time for a stick of length l’ and weight w’ if l <= l’ and w <= w’. Otherwise, it will need 1 minute for setup. You are to find the minimum setup time to process a given pile of n wooden sticks. For example, if you have five sticks whose pairs of length and weight are ( 9 , 4 ) , ( 2 , 5 ) , ( 1 , 2 ) , ( 5 , 3 ) , and ( 4 , 1 ) , then the minimum setup time should be 2 minutes since there is a sequence of pairs ( 4 , 1 ) , ( 5 , 3 ) , ( 9 , 4 ) , ( 1 , 2 ) , ( 2 , 5 ) . Input

The input consists of T test cases. The number of test cases (T) is given in the first line of the input file. Each test case consists of two lines: The first line has an integer n , 1 <= n <= 5000 , that represents the number of wooden sticks in the test case, and the second line contains 2n positive integers l1 , w1 , l2 , w2 ,…, ln , wn , each of magnitude at most 10000 , where li and wi are the length and weight of the i th wooden stick, respectively. The 2n integers are delimited by one or more spaces. Output

The output should contain the minimum setup time in minutes, one per line. Sample Input

3 5 4 9 5 2 2 1 3 5 1 4 3 2 2 1 1 2 2 3 1 3 2 2 3 1 Sample Output

2 1 3

贪心题。题目很容易懂,就不翻译了。略水,一遍 AC,久违的快感!!!hhhh,嘛,我很注意节制的(哪和哪!)

把w和l分别按第一关键字和第二关键字排序。

然后扫描一遍,如果符合 w[i]>=wk[k]&&l[i]>=lk[k] 就更新 wk[k] 和 lk[k],分别表示的是第 k 次操作下能达到的最大 w 和 l。

如果不符合,则需要增加一分钟的工作时间。同样不要忘记更新。

代码实现
 1    #include <iostream>
 2    #include <cstdio>
 3    #include <cstring>
 4    #include <cmath>
 5    #include <algorithm>
 6    #include <iomanip>
 7
 8
 9    using namespace std;
10
11    int main()
12    {
13        int t;
14        cin>>t;
15        int n;
16        int l[6666],w[6666],lk[6666],wk[6666];
17        while (t--)
18        {
19            memset(l,0,sizeof(l));
20            memset(w,0,sizeof(w));
21            memset(lk,0,sizeof(lk));
22            memset(wk,0,sizeof(wk));
23            scanf("%d",&n);
24            for (int i=1;i<=n;i++)
25                scanf("%d %d",&l[i],&w[i]);
26            for (int i=1;i<=n-1;i++)
27                for (int j=i+1;j<=n;j++)
28                 if ((l[i]>l[j])||((l[i]==l[j])&&(w[i]>w[j])))
29            {
30                swap(l[i],l[j]);
31                swap(w[i],w[j]);
32
33            }
34
35                int k;
36                int sum=1;
37                lk[1]=l[1];
38                wk[1]=w[1];
39              //  for (int i=1;i<=n;i++)
40            //        cout<<"look"<<l[i]<<"  "<<w[i]<<endl;
41             for (int i=1;i<=n;i++)
42             {
43
44                 k=1;
45                 while ((l[i]<lk[k])||(w[i]<wk[k]))
46                 {
47                     k++;
48                 //    cout<<"look"<<endl;
49                     if (k>sum) break;
50                 }
51                 if (k>sum)
52                 {
53                     sum++;
54                     lk[k]=l[i];
55                     wk[k]=w[i];
56                 }
57                 else
58                 {
59                     lk[k]=l[i];
60                     wk[k]=w[i];
61                 }
62             //    cout<<"k:"<<k<<endl;
63
64
65             }
66                  printf("%d\n",sum);
67        }
68        return 0;
69    }

Related

codeforces 447 B. DZY Loves Strings

·156 words·1 min
简单贪心。 因为填的字母没有次数限制,所以最优策略很容易想到,就是在最后面填最大的。 不用实际去填,算出ans就可以。 1 2 3 4 #include <iostream> 5 #include <cmath> 6 #include <cstring> 7 #include <algorithm> 8 9 using namespace std; 10 11 int main() 12 { 13 int k,len; 14 char st[2000]; 15 int a[2000]; 16 memset(a,0,sizeof(a)); 17 int w[50]; 18 cin>>st>>k; 19 int m=-1; 20 for (int i=1;i<=26;i++) 21 { 22 23 cin>>w[i]; 24 if (w[i]>m) 25 m=w[i]; 26 } 27 len=strlen(st); 28 for (int i=0;i<len;i++) 29 a[i]=(int)(st[i]-96); 30 long long ans=0; 31 for (int i=0;i<len;i++) 32 { 33 ans=ans+w[a[i]]*(i+1); 34 // cout<<ans<<endl; 35 } 36 for (int i=len;i<len+k;i++) 37 ans=ans+m*(i+1); 38 cout<<ans<<endl; 39 return 0; 40 }

hdu 1009 FatMouse' Trade

·267 words·1 min
简单贪心…. 需要注意的是数据是非负,所以有0的情况要考虑周全,基本都要特殊处理。 多WA了三次,不知道为什么交C++可以过,交G++就不行。 代码实现 1 2 /* *********************************************** 3 Author :111qqz 4 Created Time :2016年02月19日 星期五 16时38分28秒 5 File Name :code/hdu/1009.cpp 6 ************************************************ */ 7 8 #include <iostream> 9 #include <cstring> 10 #include <algorithm> 11 #include <cstdio> 12 #include <iomanip> 13 14 using namespace std; 15 16 int main() 17 { 18 int m,n,f[1500],j[1500]; 19 double scale[1500]; 20 double ans,sum; 21 while(scanf("%d %d",&m,&n)!=EOF&&(m!=-1)) 22 { ans=0; 23 // if (m==0) 24 memset(scale,0,sizeof(scale)); 25 memset(f,0,sizeof(f)); 26 memset(j,0,sizeof(j)); 27 // bool flag=false; 28 for (int i=1;i<=n;i++) 29 { 30 scanf("%d %d",&j[i],&f[i]); 31 if (f[i]!=0) 32 scale[i]=(double)j[i]*1.0/f[i]; 33 else if (j[i]!=0) 34 { 35 ans=ans+j[i]; 36 37 } 38 } 39 // if (flag) {cout<<fixed<<setprecision(3)<<ans<<endl;continue;} 40 for (int i=1;i<=n-1;i++) 41 for (int k=i+1;k<=n;k++) 42 if (scale[i]<scale[k]) 43 { 44 swap(scale[i],scale[k]); 45 swap(j[i],j[k]); 46 swap(f[i],f[k]); 47 } 48 sum=0; 49 int i=1; 50 while (m>=sum&&i<=n) 51 { 52 ans=ans+j[i]; 53 sum=sum+f[i]; 54 i++; 55 } 56 i--; 57 ans=ans-j[i]; 58 sum=sum-f[i]; 59 ans=ans+(m-sum)*scale[i]; 60 cout<<fixed<<setprecision(3)<<ans<<endl; 61 62 63 } 64 return 0; 65 }

hdu 1050 Moving Tables

·185 words·1 min
一开始算法想的有点问题。 坑点在于走廊两侧都有房间 也就是说room1和room2对应的位置是一样的 1 to 3 4to6 是没法同时完成的。 做法就是整个扫一遍,看哪个位置的重复次数最大,*10就是答案。

hdu 5120 - Intersection

·665 words·2 mins
题意:求两个相等的圆环的相交的面积…. 简单计算几何+容斥原理? 扇形面积公式记错调了半天2333333333 这题不难…倒是从学长那里收获了几点关于代码规范的问题… 听说了学长在北京区域赛时把PI定义错了一位结果一直WA的教训…. 以后还是写acos(-1)吧 局部变量和全局变量因为【想怎么其变量名想得整个人都不好了】就起成了一样的…被学长给了差评。 哦,对!还有一个就是发现了cmath库里有一个奇葩的函数名叫y1.。。。。。。。 —————————————————————————————————————————————— 竟然CE了 提示 error:pow(int,int) is ambiguous 看来我对语言的掌握程度还是不行呀…..

hdu 5119 - Happy Matt Friends(dp解法)

·820 words·2 mins
Description Matt has N friends. They are playing a game together. Each of Matt’s friends has a magic number. In the game, Matt selects some (could be zero) of his friends. If the xor (exclusive-or) sum of the selected friends’magic numbers is no less than M , Matt wins. Matt wants to know the number of ways to win. Input The first line contains only one integer T , which indicates the number of test cases.